﻿//DESCRIPTION:Highlight each manual line break in the text.

// Modified 2022-04-08
// Keith Gilbert, Gilbert Consulting
// www.gilbertconsulting.com

Pre();
  
function Pre () {  
	// Check to make sure all required conditions are met
	if (!app.documents.length) { 
		alert("No InDesign documents are open. Please open a document and try again.");
		return;
	}
	// Main();
	app.doScript(Main, undefined, undefined, UndoModes.ENTIRE_SCRIPT,"Run Script");
}  

function Main() {
	var myDoc = app.activeDocument;
    if (myDoc.conditions.item ("Show-hide line breaks script") != null) {
        myDoc.conditions.item ("Show-hide line breaks script").remove ();
        alert("Line break highlights removed.");
    }
	else {
		myDoc.conditions.add ({
			name: "Show-hide line breaks script", 
			indicatorColor: [200,0,0], 
			indicatorMethod: ConditionIndicatorMethod.useHighlight});				
		app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.nothing;
		app.findChangeGrepOptions.includeFootnotes = true;
		app.findChangeGrepOptions.includeHiddenLayers = false;
		app.findChangeGrepOptions.includeLockedLayersForFind = false;
		app.findChangeGrepOptions.includeLockedStoriesForFind = false;
		app.findChangeGrepOptions.includeMasterPages = true;
		app.findGrepPreferences.findWhat = "\\n"; 
		app.changeGrepPreferences.appliedConditions = [myDoc.conditions.item("Show-hide line breaks script")];
		var myFound = myDoc.changeGrep();
		// Conditional text is visible only in Normal screen mode
		app.documents[0].layoutWindows[0].screenMode = ScreenModeOptions.previewOff;
		// Show invisible characters
		myDoc.textPreferences.showInvisibles = true;
		alert("Line breaks highlighted.");
	}
}